/*
  Edi : Editor, decently intuitive
  Written by Petko Yotov (c) 2015 pmwiki.org/petko

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.

  7 helper functions marked below with [u] were inspired by functions of
  the Unverse.js library by John Goodman

  version: 20150815
*/
(function() {
  function log(x) {
    if(window.console) console.log(x);
  }

  function $(id) {  // [u]
    return (typeof id == 'string') ? document.getElementById(id) : id;
  }

  function $$(cn, tag, el) { // [u]
    el = el || document;
    var allspans = el.getElementsByTagName(tag);
    if(cn=='') return allspans;
    var e = [];
    var rx = new RegExp('\\b' + cn + '\\b');
    if(allspans) for(var i=0; i<allspans.length;i++) {
      if(rx.test(allspans[i].className))
        e.push(allspans[i]);
    }
    return e;
  }

  function cE(tag, parent) { // [u]
    parent = parent || document;
    return parent.createElement(tag);
  }

  function all(a,b){ // [u]
    for(var c=0;c<a.length;c++){
      b(a[c]);
    }
  }

  function show(id, l, t) { // [u]
    var st = $(id).style;
    if(l || t ) {
      st.position = 'absolute';
      if(l) { st.left = l + 'px'; }
      if(t) { st.top = t + 'px'; }
    }
    st.display = 'block';
  }

  function hide(id) { // [u]
    if($(id)) $(id).style.display = 'none';
  }

  function aE(el, ev, fn) { // [u]
    if(!el) return;
    return window.addEventListener
      ? el.addEventListener(ev, fn, false)
      : el.attachEvent("on" + ev, fn);
  }

  function iH(id, content) {
    if(typeof content == 'undefined') return $(id).innerHTML;
    $(id).innerHTML = content;
  }

  function ishow(id, l, t) {
    $(id).style.display = 'inline';
  }

  function cN(id, cname) {
    cname = cname || false;
    var currcn = $(id).className || '';
    if(cname) {
      var rx = new RegExp('\\b'+cname.replace(/^[+-]/, '')+'\\b', 'g');
      if(cname.charAt(0)=='+') { // add class
        cname = cname.substring(1);
        $(id).className = currcn.replace(rx, '') + ' ' + cname;
      }
      else if(cname.charAt(0)=='-') { //remove class
        cname = cname.substring(1);
        $(id).className = currcn.replace(rx, '');
      }
      else $(id).className = cname.replace(/^ +| +$/g, ''); // set class
    }
    else return $(id).className;
  }

  function unHSC(x){
    var ra = { '&amp;': '&', '&lt;': '<', '&gt;': '>', '&quot;': '"', '&#039;': "'" };
    return x.replace(/&(amp|lt|gt|quot|#039);/g, function(m) { return ra[m]; });
  };

  function repeat(str, n){
    var r = '';
    for(var i=0; i<n; i++) r+=str;
    return r;
  }

  function uploadFile(){
    if(! window.FormData) {
      iH('e_msg', EdiVars.NoFormData);
      return;
    }
    var rx = new RegExp("\\."+EdiVars.UploadExts.join('|')+"$", 'i');
    var files = $('e_upload').files;
    if(!files.length) return;


    var file = files[0];

    $('e_upload').value = '';

    var a = file.name.match(/\.([^.]+)$/);
    var ext = (a) ? a[1] : '';
    if(! file.name.match(rx)) {
      iH('e_msg', file.name + ': '+EdiVars.ULbadtype.replace(/\$upext/g, ext));
      return;
    }

    var formdata = new FormData();
    formdata.append('uploadfile', file, file.name);
    formdata.append("n", EdiVars.PageName);
    formdata.append("action", "postupload");
    formdata.append("edi-ajax", "1");

//     if($('e_authid').value) formdata.append("authid", $('e_authid').value);
//     if($('e_authpw').value) formdata.append("authpw", $('e_authpw').value);

    var xhr = new XMLHttpRequest();
    xhr.open("POST", EdiVars.PageUrl);
    xhr.send(formdata);
    iH('e_msg', EdiVars.UploadingFile);

    xhr.onreadystatechange = function() {
      if (xhr.readyState == 4 && ((xhr.status >= 200 && xhr.status <= 200) || xhr.status == 304) && xhr.responseText != "") {
        var reply = xhr.responseText, F=file.name, R='unknown_error';
        //&uprname=K.png&upresult=tquota
        var m = reply.match(/uprname=([^&]+)(&|$)/);
        if(m) F=m[1];
        var m = reply.match(/upresult=([^&]+)(&|$)/);
        if(m) R=m[1];
        var m = reply.match(/name=(['"])(authpw|password)\1/);
        if(m) {
          R='passreq';
          alert("Not authentified")
//           show('e_authform');
        }
        if(EdiVars.hasOwnProperty('UL'+R)) {
          iH('e_msg', F + ': ' + EdiVars['UL'+R].replace(/\$upext/g, ext));
        }
        if(R == 'success') {
          $('e_files').options.add(new Option(F), 1);
        }
      }
    }
  }

  function insLink(sel) {
    var i = sel.selectedIndex;
    if(i==0) return;
    var val = sel[i].text;
    if(sel.id == 'e_files') val = '+'+val;
    else val = '@' +val;
    insMarkup(val +' "', '"', 'link text');
    sel.selectedIndex = 0;
    $('text').focus();
  }

  function prevS(el, rx) {
    if(el.previousSibling) var ps = el.previousSibling;
    else return false;
    while (! ps.nodeName.match(rx) )
      if(ps.previousSibling) ps = ps.previousSibling;
      else return false;
    return ps;
  }

  function parN(el, rx) {
    if(el.parentNode) var p = el.parentNode;
    else return false;
    while (! p.nodeName.match(rx) )
      if(p.parentNode) p = p.parentNode;
      else return false;
    return p;
  }

  function nextS(el, rx) {
    if(el.nextSibling) var ns = el.nextSibling;
    else return false;
    while (! ns.nodeName.match(rx) )
      if(ns.nextSibling) ns = ns.nextSibling;
      else return false;
    return ns;
  }

  function offset(el){
    var xy = [el.offsetLeft, el.offsetTop];
    if(el.offsetParent) {
      var XY = offset(el.offsetParent) ;
      xy = [ xy[0]+XY[0], xy[1]+XY[1] ];
    }
    return xy;
  }

  function resizeform(){
    ta = editarea;
    ta.style.height = 'auto';
    var h = ta.scrollHeight;
    var d = document;
    var de = d.documentElement ? d.documentElement : d.body;
    var max = de.clientHeight || window.innerHeight - 18;
    ta.style.height = Math.max(32, Math.min(h, max-20))+'px';
  }

  function emenu(el, gotoedit) { // clicked on elnk
    if(undermenu) {
      cN(undermenu, '-hover');
      undermenu = 0;
    }

    if(edited) return;

    undermenu = el.parentNode;
    
    if(gotoedit) {
      edit('e_edit');
      return;
    }

    var mitems = $$('', 'p', dd);
    all(mitems, show);
    mitems = $$('', 'span', dd);
    all(mitems, ishow);

    var blockrx = /^(P|H[1-6]|FIELDSET|[UO]L|TABLE|PRE)$/;
    switch(undermenu.nodeName) {
      case 'P':
      case 'H2':
      case 'H3':
      case 'H4':
      case 'FIELDSET':
      case 'PRE':
        var z = 'rdel ulol ali lup ldn rup rdn tup tdn atr';
        if(! prevS(undermenu, blockrx))  z += ' up';
        if(! nextS(undermenu, blockrx))  z += ' dn';
        if(! undermenu.nodeName.match(/^H/)) z += ' h234';
        else //z += ' a'+ undermenu.nodeName.toLowerCase();
          cN('e_h234', undermenu.nodeName);
        break;
      case 'LI':
        cN('e_ulol', undermenu.parentNode.nodeName);
        var z = 'rdel rup rdn tup tdn atr h234';
        var p = parN(undermenu, /^[OU]L$/);
//         if(p.nodeName == 'UL') z+=' lul';
//         if(p.nodeName == 'OL') z+=' lol';
        var ps = prevS(undermenu, /^LI$/),
            ns = nextS(undermenu, /^LI$/);
        if(! ps)  z += ' up'; // this is the first item, hide "move up"
        else z += ' lup ulol';     // not first item, hide "list up", ordered, bulletted
        if(! ns)  z += ' dn'; // this is the last item, hide "move down"
        else z += ' atr ah awt ldn apre aul atable apar atr'; // not last, hide "Add*" and "list down"
        var pp = undermenu.parentNode;
        if(! prevS(pp, blockrx))  z += ' lup';
        if(! nextS(pp, blockrx))  z += ' ldn';
        break;
      case 'TD':
      case 'TH':
        var tr = parN(undermenu, /^TR$/);
        var z = 'del ulol li up dn lup ldn h234'
        if(! prevS(tr, /^TR$/)) z += ' rup'; // first one
        else z += ' tup';
        if(! nextS(tr, /^TR$/)) z += ' rdn'; // last one
        else z += ' apar ali aul ah awt tdn apre atable';
        var pp = parN(tr, /^TABLE$/);
        if(! prevS(pp, blockrx))  z += ' tup'; // first one
        if(! nextS(pp, blockrx))  z += ' tdn'; // last one
        break;
    }
    all(z.split(/ /g), function(x){ hide('e_'+x); });

    var xy = offset(el);
    var l = xy[0]+el.offsetWidth-dd.offsetWidth;
    show(dd, l, xy[1]+el.offsetHeight);
    cN(undermenu, '+hover');
  }

  function getWikiHTML(fieldset) {
    var code = fieldset.getAttribute('data-edi-content');
    var xhr;
    if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
    else if (window.ActiveXObject) xhr = new ActiveXObject("Microsoft.XMLHTTP");
    else return false;

    if(fieldset.nodeName == 'FIELDSET') {
      var c = edited.firstChild;
      var e = nextS(c, /^DIV$/);
      var engine = 'pmwiki';
    }
    else {
      var e = fieldset;
      var engine = 'edi';
    }

    var send = 'action=edirender'
      + "&engine="+engine
      + "&n="+encodeURIComponent(EdiVars.PageName)
      + "&markup="+encodeURIComponent(code);

//     log(code);

//     if($('e_authid').value) send += "&authid=" + encodeURIComponent($('e_authid').value);
//     if($('e_authpw').value) send += "&authpw=" + encodeURIComponent($('e_authpw').value);

    xhr.open("POST", EdiVars.PageUrl + "?rnd="+Math.random(),true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.send(send);

    xhr.onreadystatechange = function() {
      if(xhr.readyState != 4) return;
      var rt = xhr.responseText;
      if(xhr.status != 200 || rt.indexOf('ERROR')>=0) {
        e.innerHTML = "ERROR: (status = "+xhr.status+" || responseText == '"+rt+"')";
      }
      else e.innerHTML = rt;
      cN(fieldset, '-editing');
      cN(fieldset, '-loading');
      if(fieldset.className != 'FIELDSET') addmenubtn(fieldset);
    };
  }

  function donefn() {
    var newline = $('text').value;

    BACKUP = newline.replace(/\n/g, '<br/>')

    if(edited.nodeName.match(/^T[HD]$/) && ! newline.length) newline = ' ';
    datacontent(edited, newline);

    getWikiHTML(edited, newline);

    e3div_cn(edited, '+unsaved');
    cancelfn(1);
  }

  function cancelfn(did) {
    hide(editform);
    $('wikitext').appendChild(editform);
    show(dd, -2000);

    var wt = (edited.nodeName == 'FIELDSET') ? 1:0;


    if(edited && BACKUP == '' && ! edited.nodeName.match(/^T[HD]$/)) {
      editfn.e_del(edited, 'quiet');
      edited = 0;
    }
    else if(edited) {
      if(wt) {
        var c = edited.firstChild;
        p = nextS(c, /^DIV$/);
        iH(p, BACKUP);
      }
      else {
        if(BACKUP.indexOf("e3menubtn")) {
          BACKUP = BACKUP.replace(/<span[^>]*e3menubtn[^>]*>[^<]*<\/span>/gi, "");
        }
        iH(edited, BACKUP);
        addmenubtn(edited);
      }
//       cN(edited, (typeof did != 'undefined')? 'loading': ' ');
      cN(edited, '-editing');
      if(!did) edited.className = BACKUPCN.replace(/editing|hover/, '')
         .replace(/  +/g, ' ').replace(/^ +| +$/g, '');
      edited = 0;
    }
    if(undermenu) {
      cN(undermenu, '-hover');
      undermenu = 0;
    }
  }

  function addmenubtn(par) {
    var elnk = cE('span');
    cN(elnk, 'e3menubtn');
    iH(elnk, EdiVars.MenuChar);
//     var elnk2 = cE('span');
//     cN(elnk2, 'e3editbtn');
//     iH(elnk2, EdiVars.EditChar);
    if(par.children.length) {
      par.insertBefore(elnk, par.firstChild);
//       par.insertBefore(elnk2, par.firstChild);
    }
    else {
      par.appendChild(elnk);
//       par.appendChild(elnk2);
    }
    aE(elnk, 'click', function(){ emenu(elnk, 0); });
//     aE(elnk2, 'click', function(){ emenu(elnk, 1); });
  }

  function edit(link_id) {

    if(!undermenu) return;
    if(editfn.hasOwnProperty(link_id))
      editfn[link_id](undermenu, undermenu.parentNode);
    show(dd, -2000);
    cN(undermenu, '-hover');
    undermenu = 0;
  }

  function getalldatacontent(el) {
    var d = datacontent(el);
    if(d) {
      var c = [], cn = el.className || '';
      if(cn.match(/bold/)) c.push('bold');
      if(cn.match(/red/)) c.push('red');
      if(cn.match(/frame/)) c.push('frame');
      if(c.length) d = "%"+c.join(' ')+"%" +d;

      if(el.nodeName == 'PRE') {
        d = d.replace(/%0A/gi, "\n");
      }
      else d = d.replace(/%0A/gi, "\\\\\n").replace(/\|\|/g, '%7C%7C');

      switch(el.nodeName) {
        case 'H2':
        case 'H3':
        case 'H4':
          var level = parseInt(el.nodeName.charAt(1));
          d = repeat('!', level)+' '+d+"\n\n";
          break;

        case 'PRE':
          d = '[@'+d+"@]\n\n";
          break;

        case 'P':
          d = ''+d+"\n\n";
          break;

        case 'LI':
          var prfx = el.parentNode.nodeName == 'OL'? "# " : '* ';
          d = prfx+d+"\n";
          if(! nextS(el, /^LI$/)) d += "\n";
          break;

        case 'TD':
        case 'TH':
          var prfx = el.nodeName == 'TD' ? '|| ' : '||! ';
          d = prfx+d.replace(/^ +| +$/g, '')+' ';
          if(! nextS(el, /^(TD|TH)$/)) {
            d += "||\n";
            if(! nextS(el.parentNode, /^TR$/)) d += "\n";
          }
          break;

        case 'FIELDSET':
          d = '<wiki>\n'+d+"\n</wiki>\n\n";
          break;
      }
    }
    else if(el.children) {
      for(var i=0; i<el.children.length; i++) {
        d+=getalldatacontent(el.children[i]);
      }
    }
    log(d);
    return d;
  }

  function savepage() {
    var xhr;
    if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
    else if (window.ActiveXObject) xhr = new ActiveXObject("Microsoft.XMLHTTP");
    else return false;
    log("saving page...");
    all($$('e_savelink', 'a'), function(e){ e.innerHTML = 'Saving...'; });

    var submitstr = '';
    var e3divs = $$('e3div', 'div', $('wikitext'));
    for(var i=0; i<e3divs.length; i++) {
      var div = e3divs[i];
      if(! div.className.match(/unsaved/)) continue;

      var content = getalldatacontent(div);
//       log(i);
//       log(content);
      submitstr += "&edi-"+i+"="+encodeURIComponent(content);
    }


    xhr.open("POST", EdiVars.PageUrl + "?rnd="+Math.random(),true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.send("action=edisave&n="+encodeURIComponent(EdiVars.PageName)
      +submitstr
      +"&csum="+encodeURIComponent('[edi]')
    );

    xhr.onreadystatechange = function() {
      if(xhr.readyState != 4) return;
      var rt = xhr.responseText;
      if(xhr.status != 200 || rt.indexOf('ERROR')>=0) {
        alert("ERROR: (status = "+xhr.status+" || responseText == '"+rt+"')");
      }
      else if( rt != "edi:saved") alert(rt);
      else {
        all($$('unsaved', 'div'), function(e){ cN(e, '-unsaved'); })
//         all($$('open', 'div'), function(e){ cN(e, '-open'); })
        all($$('e_savelink', 'a'), function(e){ cN(e, '-unsaved'); iH(e, 'Save'); });
      }
    };
  }

  function addfromtoolbar(el) {
    var cn = el.className || '';

    if(undermenu) {
      show(dd, -2000);
      cN(undermenu, '-hover');
      undermenu = 0;
    }

    var link_id = cn.replace(/_(bottom|top)$/, '');
    if(link_id.match(/e_savelink/)) {
      savepage();
      return;
    }
    if(! editfn.hasOwnProperty(link_id)) return;

    var pdiv = parN(el, /^DIV$/);

    var _p = cE('P');
    if(cn.match(/_top$/)) {
      var ediv = nextS(pdiv, /^DIV$/);
      ediv.insertBefore(_p, ediv.firstChild);
    }
    else if(cn.match(/_bottom$/)) {
      var ediv = prevS(pdiv, /^DIV$/);
      ediv.appendChild(_p);
    }
    hide(_p);
    undermenu = _p;
    log(link_id);
    editfn[link_id](undermenu, undermenu.parentNode);
    ediv.removeChild(_p);

  }
  // referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
  // parent.insertBefore(newNode, parent.firstChild)

  function e3div_cn(el, add_or_remove_cn) {
    var div = (el.className && el.className.match(/(^| )e3div($| )/))
      ? el : parN(el, /^DIV$/);

    while((!div.className) || (! div.className.match(/(^| )e3div($| )/)))
      div = parN(div, /^DIV$/);
    if(div) cN(div, add_or_remove_cn);
    all( $$('e_savelink', 'a'), function(a) {
      cN(a, add_or_remove_cn);
    });
  }

  function datacontent(el, data) {
    if(typeof data == 'undefined')
      return el.getAttribute('data-edi-content') || '';

    el.setAttribute('data-edi-content',
        data.replace(/\n|\|/g, function(m){return encodeURIComponent(m);}));
  }

  var editfn = {
    e_ulol: function(e, tag) {
      var rx = tag == 'UL' ? /^OL$/ : /^UL$/;
      p = parN(e, rx);
      if(!p) return;
      var l = cE(tag);
      while(p.firstChild) l.appendChild(p.firstChild);
      p.parentNode.insertBefore(l, p);
      e3div_cn(l, '+unsaved');
      p.parentNode.removeChild(p);

    },
    e_lol: function(e, p) { editfn.e_ulol(e, 'OL'); },
    e_lul: function(e, p) { editfn.e_ulol(e, 'UL'); },
    e_edit: function(e, p) {
      if(edited) cancelfn();

      var p = undermenu;
      var data = datacontent(p);
      if(data == "&nbsp;") data = ''; // empty table cells

      if(p.nodeName == 'FIELDSET') {
        var c = p.firstChild;
        p = nextS(c, /^DIV$/);
      }

      BACKUP = p.innerHTML;
      BACKUPCN = p.className || '';
      var x = Math.max(p.offsetWidth-4, 200), y = p.offsetHeight;
      var ta = $('text');
      ta.style.width = x + "px";
      ta.style.height = y + "px";

      ta.value = unHSC(data.replace(/%0A/ig, "\n").replace(/%7C/ig, '|'));

      p.innerHTML = '';
      p.appendChild(editform);
      show(editform);
      cN(undermenu, '+editing');
      if(p.nodeName.match(/^(T[HD])$/)) p.style.width = (x+4)+'px';
      edited = undermenu;
      cN(undermenu, '-hover');
      undermenu = 0;

      if(p.nodeName == 'P') {
        var st = $('e_styles');
        st.selectedIndex = 0;
        for(var ist = 1; ist<st.options.length; ist++) {
          if(! edited.className.match(new RegExp('\\b'+st.options[ist].value+'\\b'))) continue;
          st.selectedIndex = ist;
          break;
        }
        ishow('e_styles');
      }
      else hide('e_styles');

      resizeform();
      $('text').focus();
    },


    e_updn: function(e, up) {
      var rx = /^(P|H[1-6]|FIELDSET|PRE|[UO]L|LI|TABLE|TR)$/;
      if(! e.nodeName.match(rx) ) e = parN(e, rx);
      if(! e) return;
      var sbl = up ?  prevS(e, rx) : nextS(e, rx);
      if(sbl) {
        if(up) e.parentNode.insertBefore(e, sbl);
        else e.parentNode.insertBefore(sbl, e);
        e3div_cn(e, '+unsaved');
      }
    },

    e_up: function(e, p) { editfn.e_updn(e, 1); },
    e_dn: function(e, p) { editfn.e_updn(e, 0); },

    e_lup: function(e, p) { editfn.e_updn(parN(e, /^[UO]L$/), 1); },
    e_ldn: function(e, p) { editfn.e_updn(parN(e, /^[UO]L$/), 0); },

    e_rup: function(e, p) { editfn.e_updn(e, 1); },
    e_rdn: function(e, p) { editfn.e_updn(e, 0); },

    e_tup: function(e, p) { editfn.e_updn(parN(e, /^TABLE$/), 1); },
    e_tdb: function(e, p) {editfn.e_updn(parN(e, /^TABLE$/), 0); },


    e_del: function(e, quiet) {
      var rx = /^(P|H[1-6]|LI|FIELDSET|PRE|TR)$/;
      if(! e.nodeName.match(rx)) e = parN(e, rx);
      log(e.nodeName);


      var cfrm = quiet == 'quiet'? 1 : confirm(EdiVars.ConfirmDelete);
      if(cfrm) {
        e3div_cn(e, '+unsaved');
        p = e.parentNode;
        var remparent = ((! e.nodeName.match(/^(LI|TR)$/) )
          || prevS(e, /^(LI|TR)$/) || nextS(e, /^(LI|TR)$/) ) ? 0 : 1;

        p.removeChild(e);

        if(remparent) {
          if(!p.nodeName.match(/^([UO]L|TABLE)$/)) p = parN(p, /^([UO]L|TABLE)$/);
          if(p) p.parentNode.removeChild(p);
        }
      }
    },
    e_rdel: function(e, p) { editfn.e_del(e); },

    e_addsth: function(e, tag) {
      var rx = /^([UO]L|P|H[1-6]|FIELDSET|PRE|TABLE|TR|LI|UL|OL)$/;
      if(!e.nodeName.match(rx)) e = parN(e, rx);
      if(!e) return;

      var NP = cE(tag);

      if(tag != 'LI' && e.nodeName == 'LI') e = parN(e, rx);
      else if(tag == 'FIELDSET') {
        NP.innerHTML = "<legend>"+EdiVars.WikiTextBlock
          +"</legend><div>"+EdiVars.Loading+"</div>";
        addmenubtn(NP);
      }
      if(e.nextSibling) { e.parentNode.insertBefore(NP, e.nextSibling);}
      else e.parentNode.appendChild(NP);


      if(tag.match(/^[UO]L$/)) {
        li = cE('LI');
        NP.appendChild(li);
        NP = li;
      }
      else if(tag == 'TR') {
        var nbcols = e.children.length;
        for(var i=0; i<nbcols; i++) {
          var td = cE('td');
          td.innerHTML = (i+1);
          addmenubtn(td);
          NP.appendChild(td);
        }

      }

      cN(undermenu, '-hover');
      e3div_cn(NP, '+unsaved');
      if(tag != 'TR') {
        undermenu = NP;
        editfn.e_edit(NP);
      }
    },


    e_awt: function(e) { editfn.e_addsth(e, 'FIELDSET'); },
    e_ali: function(e) { editfn.e_addsth(e, 'LI'); },
    e_aol: function(e) { editfn.e_addsth(e, 'OL'); },
    e_aul: function(e) { editfn.e_addsth(e, 'UL'); },

    e_apar: function(e) { editfn.e_addsth(e, 'P'); },
    e_apre: function(e) { editfn.e_addsth(e, 'PRE'); },
    e_ah: function(e) { editfn.e_addsth(e, 'H2'); },

    e_atr: function(e) { editfn.e_addsth(e, 'TR'); },


    e_h234: function(e, tag) {
      var rx = /^H[234]$/;
      var l = cE(tag);
      while(e.firstChild) l.appendChild(e.firstChild);
      e.parentNode.insertBefore(l, e);
      e3div_cn(l, '+unsaved');
      e.parentNode.removeChild(e);

    },


    e_ah2: function(e) { editfn.e_h234(e, 'H2'); },
    e_ah3: function(e) { editfn.e_h234(e, 'H3'); },
    e_ah4: function(e) { editfn.e_h234(e, 'H4'); },


    e_atable: function(p) {
      var rx = /^([UO]L|P|H[1-6]|FIELDSET|PRE|TABLE|TR|UL|OL)$/;
      if(!p.nodeName.match(rx)) p = parN(p, rx);
      if(!p) return;

      var nbcols = parseInt(prompt(EdiVars.PromptTable, 2));
      if(isNaN(nbcols) || nbcols<1) return;

      var tb = cE('TABLE');
      tb.className = 'e3';

      if(p.nextSibling) p.parentNode.insertBefore(tb, p.nextSibling);
      else p.parentNode.appendChild(tb);

      for(var i=0; i<3; i++) {
        var tr = cE('tr');
        tb.appendChild(tr);

        var thtd = i? 'td' : 'th';
        for(var j=0; j<nbcols; j++) {
          var td = cE(thtd);
          var content = i? EdiVars.TableCell : EdiVars.TableHead;
          td.innerHTML = content + ' ' + (j+1);
          addmenubtn(td);
          tr.appendChild(td);
        }
      }
    },

    end_editfn_no_comma: ''
  } // end editfn

  var KPV = [], dd = $('e3dropdown'), undermenu = 0, edited = 0,
    editarea = $('text'), editform = $('e3form'), BACKUP='', BACKUPCN='';

  function init() {
    // fill select dropdowns with pages and files
    // could be directly in HTML ?
    var s = $('e_pages');
    if(s) all(EdiVars.GroupPages, function(pn) { s.options[s.length] = new Option(pn);});
    if(s) aE(s, 'change', function(){insLink( $('e_pages') ); });

    var s = $('e_files');
    if(s) all(EdiVars.GroupFiles, function(fn) { s.options[s.length] = new Option(fn);});
    if(s) aE(s, 'change', function(){insLink( $('e_files') ); });

    // attach events to edit form
    aE($('e_done'),   'click', function(){ donefn() ;});
    aE($('e_cancel'), 'click', function(){ cancelfn() ;});
    aE(editarea, 'keyup', resizeform);
    aE(editarea, 'focus', resizeform);
    aE($('e_styles'), 'change', function(){
      var s = $('e_styles').options[$('e_styles').selectedIndex].value;
      cN(edited, (s) ? s : ' ');
    });
    aE($('e_upload'), 'change', uploadFile);
    
    
    
    
//     aE($('e_login'),   'click', function(){
//       iH('e_msg', 'Ok');
//       hide('e_authform');
//     });

//     var s = $$('e3menubtn', 'span', $('wikitext')); // attach "click" event to menu buttons
//     all(s, function(e){
//       aE(e, 'click', function(){ emenu(e, 0); });
      
//       e.parentNode.setAttribute('contenteditable', true);
//       aE(e.parentNode, 'focus', function(){
//         e.parentNode.innerHTML = e.parentNode.getAttribute('data-edi-content');
//       });
      
//       aE(e.parentNode, 'mousedown', function(){ MouseDownId = setTimeout(function(){emenu(e, 1);}, 600) ;});
//       aE(e.parentNode, 'mouseup', function(){clearTimeout(MouseDownId); MouseDownId = null; return true;});
//     });
//     var s = $$('e3editbtn', 'span', $('wikitext')); // attach "click" event to edit buttons
//     all(s, function(e){ 
//       aE(e, 'click', function(){ emenu(e, 1); });
//     });
    
    // attach "click" event to dropdown entries
//     all( $$('', 'p', dd), function(e){
//       if(e.id && ! e.id.match(/^e_(h234)|e_ulol$/))
//         aE(e, 'click', function(){ edit(e.id);});
//     });
//     all( $$('', 'span', dd), function(e){
//       if(e.id)
//         aE(e, 'click', function(){ edit(e.id);});
//     });

    // Make page editable
//     all( $$('e_editlink', 'a', $('wikitext')), function(a){
//       aE(a, 'click', function(){
//         cN(parN(a, /^DIV$/).parentNode, '+open');
//       });
//     });
     all( $$('ediwrap', 'div', $('wikitext')), function(el){
      cN(el, '+open');
    });
    
    all($$('e3div', 'div', $('wikitext')), function(d){
      all(d.children, setContentEditables);
    });

//     setContentEditables($('wikitext'));
    
    // attach events to toolbars
    all( $$('e_tools', 'p', $('wikitext')) , function(p) {
      all( $$('', 'a', p), function(a) {
        aE(a, 'click', function(){ addfromtoolbar(a); } );
      });
    });

    aE(document, 'keydown', function(evt){// cancel editing or close menu
      evt = evt || window.event;
      if (evt.keyCode == 27) cancelfn();
    });

    aE(document, 'click', function(evt){// close menu if click outside
      if(!undermenu) return;
      evt = evt || window.event;
      var el = evt.target;
      if(!el) {
        var so = /Safari|Opera/.test(navigator.userAgent),
          x = so ? evt.pageX : evt.clientX,
          y = so ? evt.pageY : evt.clientY;
        el = document.elementFromPoint(x, y);
      }
      if (el.id != 'e3dropdown'
        && el.parentNode.id != 'e3dropdown'
        && el.className != 'e3menubtn' ) {
        show(dd, -2000);
        cN(undermenu, '-hover');
        undermenu = 0;
      }
    });
  }
  
  function setContentEditables(el) {
    if(el.getAttribute('data-edi-content')) {
      
      el.setAttribute('contenteditable', true);
      
      aE(el, 'focus', function(){
        
        BACKUP = el.innerHTML;
        el.innerHTML = el.getAttribute('data-edi-content').replace(/%0a/gi, '<br/>');
        var xy = offset(el);
        var tools = $('e3formZ');
        show(tools, xy[0], xy[1]-tools.offsetHeight);
        
        
      });
      aE(el, 'blur', function(){
        show($('e3formZ'), -2000);
        var t = el.innerHTML
          .replace(/[\r\n]+/g, '')
          .replace(/<br[^>]*>/ig, "\n")
          .replace(/^[\r\n]+|[\r\n]+$|<\w+[^>]*>/g, '');
        var tt = t.replace(/\n/g, '%0A');
//         log([el.getAttribute('data-edi-content'), tt]);
        
        
        if(el.getAttribute('data-edi-content') == tt) {
          el.innerHTML = BACKUP;
          BACKUP = '';
          return;
        } // else
        
        el.setAttribute('data-edi-content', tt);
        getWikiHTML(el);
        e3div_cn(el, '+unsaved');;
      });
    }
    else if(el.children.length) {
      for(var i=0; i<el.children.length; i++) {
        setContentEditables(el.children[i]);
      }
    }
  }
  

  init();
})();
